const OMNIBOX_KEYWORD = "techsaptool_paste";
const MENU_TECHSPATOOL_COPY_ID = "MENU_TECHSPATOOL_COPY";
const MENU_TECHSPATOOL_PASTE_ID = "TECHSPATOOL_PARSE";
const AES_KEY = "iLFB0yJSLsObtH6tNcfXMqo7L8qcEHqZ";
const MENU_TEXT_COPY = "[]Copy Techsaptool in This Page to Clipboard";
const MENU_TEXT_PASTE = "[]Parse Techsaptool from Clipboard in New Tab";
var backgroundPage = chrome.extension.getBackgroundPage();
backgroundPage.handleCopyClick = handleCopyClick;
backgroundPage.handlePasteClick = handlePasteClick;

// 
chrome.contextMenus.create({
    id: MENU_TECHSPATOOL_COPY_ID,
    title: MENU_TEXT_COPY,
});

// 
chrome.contextMenus.create({
    id: MENU_TECHSPATOOL_PASTE_ID,
    title: MENU_TEXT_PASTE
});

// 
var copyToClipboard = function(text) {
    // var backgroundPage = chrome.extension.getBackgroundPage();
    var clipboard = backgroundPage.document.getElementById("clipboard");
    clipboard.value = text;
    clipboard.select();
    backgroundPage.document.execCommand("Copy");
};

// 
var pasteFromClipboard = function() {
    // var backgroundPage = chrome.extension.getBackgroundPage();
    var clipboard = backgroundPage.document.getElementById("clipboard");
    clipboard.value = text;
    clipboard.select();
    var text = '';
    if (document.execCommand('paste')) {
        text = clipboard.value;
    }
    clipboard.value = '';
    return text;
}

// 
function handleCopyClick(pageUrl) {
    var cookie_data = getDomainCookies(pageUrl, function(cookies) {
        cookies = JSON.stringify(cookies);
        var encrypted = CryptoJS.AES.encrypt(cookies, AES_KEY);
        copyToClipboard(
            // 
            OMNIBOX_KEYWORD + " " + encrypted
        );
    });
}

//
function handlePasteClick() {
    var text = pasteFromClipboard();
    if (text.indexOf(OMNIBOX_KEYWORD) !== 0) {
        alert('[]Has no techspatool in your clipboard!');
        return false;
    }
    solveTechspatoolPaste(text.substr(OMNIBOX_KEYWORD.length + 1));
}

// 
chrome.contextMenus.onClicked.addListener(function(info, tab) {
    switch (info.menuItemId) {
        case MENU_TECHSPATOOL_COPY_ID:
            handleCopyClick(info.pageUrl);
            break;
        case MENU_TECHSPATOOL_PASTE_ID:
            handlePasteClick();
            break;
        default:
    }
});

// techspatool
function solveTechspatoolPaste(text) {
    try {
        var decrypted = CryptoJS.AES.decrypt(text, AES_KEY);
        text = decrypted.toString(CryptoJS.enc.Utf8);
        var data = JSON.parse(text);
        var url = loadCookies(data);
        chrome.tabs.update({
            url: url
        });
    } catch (err) {
        alert("Catch an error when paste techspatool: " + err.toString());
    }
}

// 
chrome.omnibox.onInputEntered.addListener(solveTechspatoolPaste);

//
var updateOmniboxSuggestion = function(text) {
    var description = "Paste Techspatool Here";
    if (text) {
        try {
            var cookie_data = JSON.parse(text);
            if (cookie_data && cookie_data.url) {
                description = "Paste Techspatool <url>" + cookie_data.url + "</url>";
            }
        } catch (e) {
            console.warn('Activation key paste maybe catch an error~', e);
        }
    }
    chrome.omnibox.setDefaultSuggestion({
        description: description
    });
};
updateOmniboxSuggestion();

chrome.omnibox.onInputStarted.addListener(updateOmniboxSuggestion);
chrome.omnibox.onInputChanged.addListener(updateOmniboxSuggestion);
